import request from '@/config/axios'
import { isEmpty1 } from '@/utils/is'

// 查询交易中心配置详情
export const getTradeConfig = async () => {
  return request.get({
    url: '/app-api/trade/config/get',
  })
}

// 创建订单
export const createOrder = async (data) => {
  return await request.post({
    url: '/app-api/trade/order/create',
    data
  })
}

// 计算订单信息
export const settlementOrder = async (data) => {
    const data2 = {
      ...data,
    };
    // 移除多余字段
    if (!(data.couponId > 0)) {
      delete data2.couponId;
    }
    if (!(data.addressId > 0)) {
      delete data2.addressId;
    }
    if (!(data.pickUpStoreId > 0)) {
      delete data2.pickUpStoreId;
    }
    if (isEmpty1(data.receiverName)) {
      delete data2.receiverName;
    }
    if (isEmpty1(data.receiverMobile)) {
      delete data2.receiverMobile;
    }
    if (!(data.combinationActivityId > 0)) {
      delete data2.combinationActivityId;
    }
    if (!(data.combinationHeadId > 0)) {
      delete data2.combinationHeadId;
    }
    if (!(data.seckillActivityId > 0)) {
      delete data2.seckillActivityId;
    }
    if (!(data.pointActivityId > 0)) {
      delete data2.pointActivityId;
    }
    if (!(data.deliveryType > 0)) {
      delete data2.deliveryType;
    }
    // 解决 SpringMVC 接受 List<Item> 参数的问题
    delete data2.items;
    if (data?.items?.length) {
      for (let i = 0; i < data.items.length; i++) {
        data2[encodeURIComponent('items[' + i + '' + '].skuId')] = data.items[i].skuId + '';
        data2[encodeURIComponent('items[' + i + '' + '].count')] = data.items[i].count + '';
        if (data.items[i].cartId) {
          data2[encodeURIComponent('items[' + i + '' + '].cartId')] = data.items[i].cartId + '';
        }
      }
    }
    const queryString = Object.keys(data2)
      .map((key) => key + '=' + data2[key])
      .join('&');
  return request.get({
    url:  `/app-api/trade/order/settlement?${queryString}`
  })
}

// 获得支付订单
export const getOrder = async (id, sync) => {
  return request.get({
    url: '/app-api/pay/order/get',
    params: { id, sync }
  })
}

// 创建订单
export const submitOrder = async (data) => {
  return await request.post({
    url: '/app-api/pay/order/submit',
    data
  })
}
