/**
 * encryptionFun()
  示例1 http://xxx.com?id=123
  encryptionFun('id=123')

  示例2 http://xxx.com   {"id":123}
  encryptionFun('{"id":123}')

  示例3 http://xxx.com?id=123&name=张三   {"id":123}
  encryptionFun('id=123&name=张三{"id":123}')
*/

import { generateUUID } from "@/utils/index" 
import { sha256 } from 'js-sha256'

/**
 * 
 * @param { str } raw 参数用&隔开
 * @param { Object } body
 * @returns 
*/
export const encryptionFun = ({raw, body, appId, AppSecret, timestamp}) => {
  const initSign = {
    appId,
    nonce: generateUUID(),
    timestamp,
  }
  const _initSignArr = Object.keys(initSign).map(key => {
    return `${key}=${initSign[key]}`
  })
  const _initSign = _initSignArr.join('&')

  const paramsStr = _initSign + AppSecret
  let str = ''
  if (raw) {
    str += decodeURIComponent(raw)
  }
  if (body && Object.keys(body).length) {
    str += decodeURIComponent(JSON.stringify(body))
  }
  const noSign = str + paramsStr
  return {
    ...initSign,
    noSign: noSign,
    sign: sha256(noSign)
  }
}
